///distribute_homes()
//Try to give homeless people a home
var homeless = ds_list_create();

with (citizen)
{
    if (home == noone)
    {
        ds_list_add(homeless, id);
    }
}

totalHomeCapacity = 0;

with (house)
{
    if (ds_list_size(inhabitants) < maxInhabitants)
    {
        //We can give someone a home!
        //Max one per step, that's okay
        if (!ds_list_empty(homeless))
        {
            var givehometo = homeless[| ds_list_size(homeless) - 1];
            ds_list_add(inhabitants, givehometo);
            givehometo.home = id;
            ds_list_delete(homeless, ds_list_size(homeless) - 1);
        }
    }
    other.totalHomeCapacity += maxInhabitants;
}

homelessNumber = ds_list_size(homeless);
ds_list_destroy(homeless);

//Also, move up to one person to a better house
var citizenInWorstHouse = noone, worstLivingHappiness = 100;
with (citizen)
{
    if (home != noone)
    {
        if (home.livingHappiness < worstLivingHappiness)
        {
            worstLivingHappiness = home.livingHappiness;
            citizenInWorstHouse = id;
        }
    }
}

if (citizenInWorstHouse != noone)
{
    var bestNewHouse = noone, bestNewLivingHappiness = worstLivingHappiness;
    with (house)
    {
        if (ds_list_size(inhabitants) < maxInhabitants)
        {
            if (livingHappiness > bestNewLivingHappiness)
            {
                bestNewLivingHappiness = livingHappiness;
                bestNewHouse = id;
            }
        }
    }
    
    if (bestNewHouse != noone)
    {
        //Move the citizen
        var currentHome = citizenInWorstHouse.home;
        ds_list_delete(currentHome.inhabitants, ds_list_find_index(currentHome.inhabitants, citizenInWorstHouse));
        ds_list_add(bestNewHouse.inhabitants, citizenInWorstHouse);
        citizenInWorstHouse.home = bestNewHouse;
    }
}
