///distribute_work()
//Make sure all people have work if possible, and all high priority work has workers

//Check for unfulfilled high priority work
with (work)
{
    if (priorityJobNumber > ds_list_size(workers))
    {
        //We need more people here!
        var bestVoluntier = noone, bestVoluntierDesirability = -1;
        
        //Get the best voluntier
        with (citizen)
        {
            var desirability = -2;
            if (job == noone)
                desirability = 1000;
            else if (job.jobs > job.priorityJobNumber)
                desirability = (ds_list_size(job.workers) - job.priorityJobNumber) / job.jobs;
            if (desirability > bestVoluntierDesirability)
            {
                bestVoluntier = id;
                bestVoluntierDesirability = desirability;
            }
        }
        
        //If we have one, assign it
        if (bestVoluntier != noone)
        {
            //Assign this person to this job
            var currentJob = bestVoluntier.job;
            if (currentJob != noone)
            {
                ds_list_delete(currentJob.workers, ds_list_find_index(currentJob.workers, bestVoluntier));
            }
            
            bestVoluntier.job = id;
            ds_list_add(workers, bestVoluntier);
            bestVoluntier.hasJobMaterials = false;
        }
    }
}

workingPeople = 0;

with (citizen)
{
    if (job == noone)
    {
        //Assign to the job with the least workers
        var bestJob = noone, leastCurrentWorkers = 10000;
    
        with (work)
        {
            var currentWorkers = ds_list_size(workers);
            if (currentWorkers < jobs && currentWorkers < leastCurrentWorkers)
            {
                leastCurrentWorkers = currentWorkers;
                bestJob = id;
            }
        }

        //If we found a possible job...
        if (bestJob != noone)
        {
            //We now got a job!
            ds_list_add(bestJob.workers, id);
            job = bestJob;
            other.workingPeople += 1;
            hasJobMaterials = false;
        }
    }
    else
        other.workingPeople += 1;
}

totalJobs = 0;

with (work)
{
    other.totalJobs += jobs;
}
